package com.vincenzomanzoni.client;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

import java.net.*;
import java.io.*;

public class ClientFrame
    extends JFrame {
  private JPanel contentPane;
  private BorderLayout borderLayout1 = new BorderLayout();
  private JButton jButtonSend = new JButton();
  private JScrollPane jScrollPane1 = new JScrollPane();
  private JTextArea jTextAreaSend = new JTextArea();

  private Socket socket;
  private int port = 10000;
  private PrintWriter writer;
  private BufferedReader reader;

  //Construct the frame
  public ClientFrame() {
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try {
      jbInit();
      socket = new Socket("127.0.0.1", port);
      writer = new PrintWriter(new BufferedWriter(new OutputStreamWriter(socket.
          getOutputStream())), true);
      reader = new BufferedReader(new InputStreamReader(socket.getInputStream()));
    }
    catch (Exception e) {
      e.printStackTrace();
    }
  }

  //Component initialization
  private void jbInit() throws Exception {
    //setIconImage(Toolkit.getDefaultToolkit().createImage(ClientFrame.class.getResource("[Your Icon]")));
    contentPane = (JPanel)this.getContentPane();
    jButtonSend.setText("Send");
    jButtonSend.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jButtonSend_actionPerformed(e);
      }
    });
    contentPane.setLayout(borderLayout1);
    this.setSize(new Dimension(400, 300));
    this.setTitle("Client");
    contentPane.add(jButtonSend, BorderLayout.SOUTH);
    contentPane.add(jScrollPane1, BorderLayout.CENTER);
    jScrollPane1.getViewport().add(jTextAreaSend, null);
  }

  //Overridden so we can exit when window is closed
  protected void processWindowEvent(WindowEvent e) {
    super.processWindowEvent(e);
    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
      System.exit(0);
    }
  }

  void jButtonSend_actionPerformed(ActionEvent e) {
    writer.println(jTextAreaSend.getText());
    try {
      String answer = reader.readLine();
      jTextAreaSend.setText(answer);
    }
    catch (IOException ex) {
    }
  }
}
