package com.vincenzomanzoni.server;

import java.net.*;

public class ServerBase
    extends Thread {
  private Manager manager;
  private int port;

  /*  Il costruttore  */

  public ServerBase(Manager amanager, int port) {
    manager = amanager;
    this.port = port;
  }

  /* Si pone in ascolto sulla porta locale e, per ogni richiesta di
   connessione, istanzia un server dedicato al client che lo ha contattato. */

  public void run() {
    ServerSocket serversock = null;
    Socket new_socket = null;
    ServerDedicato sd;

    // Creazione del ServerSocket
    try {
      serversock = new ServerSocket(port);
    }
    catch (Exception e) {
      System.out.println("Impossibile aprire un ServerSocket sulla porta " +
                         port);
      System.out.println(e);
    }

    // Attesa di tutte le connessioni che arrivano
    while (true) {
      try {
        new_socket = serversock.accept();

        sd = new ServerDedicato(new_socket, manager);
        sd.start();
      }
      catch (BindException e) {
        System.out.println("Impossibile la bind su " + port);
      }
      catch (Exception e) {
        System.out.println(e);
      }
    }
  }
}
