package com.vincenzomanzoni.server;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class ServerFrame
    extends JFrame {
  private JPanel contentPane;
  private BorderLayout borderLayout1 = new BorderLayout();
  private JButton jButtonShow = new JButton();
  private JScrollPane jScrollPane1 = new JScrollPane();
  private JTextArea jTextAreaMessages = new JTextArea();

  int port = 10000;
  private Manager manager = new Manager();
  private ServerBase server = new ServerBase(manager, port);

  //Construct the frame
  public ServerFrame() {
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try {
      jbInit();
      server.start();
    }
    catch (Exception e) {
      e.printStackTrace();
    }
  }

  //Component initialization
  private void jbInit() throws Exception {
    //setIconImage(Toolkit.getDefaultToolkit().createImage(ServerFrame.class.getResource("[Your Icon]")));
    contentPane = (JPanel)this.getContentPane();
    jButtonShow.setText("Show messages");
    jButtonShow.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jButtonShow_actionPerformed(e);
      }
    });
    contentPane.setLayout(borderLayout1);
    this.setSize(new Dimension(462, 368));
    this.setTitle("Server");
    contentPane.add(jButtonShow, BorderLayout.SOUTH);
    contentPane.add(jScrollPane1, BorderLayout.CENTER);
    jScrollPane1.getViewport().add(jTextAreaMessages, null);
  }

  //Overridden so we can exit when window is closed
  protected void processWindowEvent(WindowEvent e) {
    super.processWindowEvent(e);
    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
      System.exit(0);
    }
  }

  void jButtonShow_actionPerformed(ActionEvent e) {
    jTextAreaMessages.setText(manager.toString());
  }
}
